;*=====================================================================*/
;*    serrano/prgm/project/bigloo/recette/object5.scm                  */
;*    -------------------------------------------------------------    */
;*    Author      :  Manuel Serrano                                    */
;*    Creation    :  Sun Dec 24 13:29:40 2000                          */
;*    Last change :  Fri Jun 16 08:19:59 2006 (serrano)                */
;*    Copyright   :  2000-06 Manuel Serrano                            */
;*    -------------------------------------------------------------    */
;*    Testing the classes indexed slots and the introspection          */
;*    facilities within the evaluator.                                 */
;*=====================================================================*/

;*---------------------------------------------------------------------*/
;*    Le module                                                        */
;*---------------------------------------------------------------------*/
(module object5
   (import  (main "main.scm"))
   (include "test.sch")
   (export (test-object5))
   (static (class object5 (x (default 1)) (y (default 1)) (z (default '()))))
   (export (class object6 (rec (default (object6-nil)))))
   (eval (class object5)
	 (class object6)))

;*---------------------------------------------------------------------*/
;*    test-object5 ...                                                 */
;*---------------------------------------------------------------------*/
(define (test-object5)
   (test-module "object5" "object5.scm")
   (test "instantiate" (object5? (eval '(instantiate::object5))) #t)
   (test "with.access.1" (eval '(let ((o (instantiate::object5)))
				   (with-access::object5 o (x y)
				      (+ x y))))
	 2)
   (test "with.access.2" (eval '(let ((o (instantiate::object5)))
				   (with-access::object5 o (x)
				      (let ((x 10))
					 x))))
	 10)
   (test "with.access.3" (eval '(let ((o (instantiate::object5)))
				   (let ((x 10))
				      (with-access::object5 o (x)
					 x))))
	 1)
   (test "with.access.4" (eval '(let ((o (instantiate::object5)))
				   (with-access::object5 o (x y)
				      (let ((y 10))
					 (+ x y)))))
	 11)
   (test "with.access.5" (eval '(let ((o (instantiate::object5)))
				   (let ((y 10))
				      (with-access::object5 o (x y)
					 (+ x y)))))
	 2)
   (test "with.access.6" (eval '(let ((o (instantiate::object5)))
				   (let ((y 10))
				      (with-access::object5 o (x)
					 (+ x y)))))
	 11)
   (test "with.access.7" (eval '(let ((o (instantiate::object5)))
				   (let ((y 10))
				      (with-access::object5 o ((x1 x))
					 (+ x1 y)))))
	 11)
   (test "with.access.8" (eval '(let ((o (instantiate::object5))
				      (o2 (instantiate::object5 (x 2))))
				   (with-access::object5 o ((x1 x))
				      (with-access::object5 o2 ((x2 x))
					 (cons x1 x2)))))
	 '(1 . 2))
   (test "with.access.9" (eval '(let ((o (instantiate::object5))
				      (o2 (instantiate::object5 (x 2))))
				   (with-access::object5 o ((x1 x))
				      (let ((x1 3))
					 (with-access::object5 o2 ((x2 x))
					    (cons x1 x2))))))
	 '(3 . 2))
   (test "with.access.10" (eval '(let ((o (instantiate::object5))
				       (o2 (instantiate::object5 (x 2))))
				    (with-access::object5 o ((x1 x))
				       (let* ((x1 3)
					      (y x1))
					  (with-access::object5 o2 ((x2 x))
					     (cons y x2))))))
	 '(3 . 2))
   (test "-nil" (eval '(let ((o (instantiate::object6)))
			  (eq? (object6-rec o) (object6-nil))))
	 #t)
   (eval '(define-generic (show o) 1))
   (eval '(define-generic (show2 o) 0))
   (eval '(define-method (show o::object5) 5))
   (eval '(define-method (show o::object6) 6))
   (test "eval.generic.1" (eval '(show (instantiate::object5))) 5)
   (test "eval.generic.2" (eval '(show (instantiate::object6))) 6)
   (test "eval.generic.3" (eval '(show #f)) 1))

